#include <NewPing.h>      // Libreria per il sensore
#include <medianFilter.h> // libreria per il median filter

medianFilter Filter;

#define TRIGGER_PIN 5    // Pin PWM del trigger
#define ECHO_PIN  6      // Pin PWM dell'echo
#define MAX_DISTANCE 100 // Distanza massima in cm.
 
NewPing sonar(TRIGGER_PIN, ECHO_PIN, MAX_DISTANCE);
 
int SetDistance = 0;
int ValueDist   = 0;
int valFilt;
 
void setup() {
 Serial.begin(9600);
 Filter.begin();
}
 
void loop() {
 delay(100);                        // Aspetta 100ms tra i pings. 
                                   // (29ms minimo) 
 unsigned int uS = sonar.ping();   // Manda il pings, rileva il 
                                   // ritorno in microsecondi (uS).
 ValueDist = uS / US_ROUNDTRIP_CM; // Calcola la distanza (converte 
                                   // il tempo di ping in distanza 
                                   // in cm)
 valFilt = Filter.run(ValueDist);  // Valori filtrati
 Serial.println(valFilt); 
}
